
/**************************************************************************
 *
 *  Othello II v2.53 - 08/02/2004
 *
 *  Copyright (C) 2000-2004 Franois LEIBER <http://leiber.free.fr>
 *
 *	This file is part of Othello II.
 *
 *	Othello II is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	Othello II is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *************************************************************************/


unsigned short RotationPion = 0, PionOrdonnee = 0;	// Etat de rotation des pions dans le menu
short   Barre = 0;				// Avancement de la Barre de rflexion
short   Message[2] = { 0, 0 };

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche un nombre dans une police personnalise
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
print_nbre(short y, short n)
{
	static unsigned char police[] = { 0, 9, 0, 5, 0x60, 0x90, 0x90, 0x90, 0x00, 0x90, 0x90, 0x90, 0x60, 0,
		0, 9, 0, 5, 0x00, 0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x10, 0x00, 0,
		0, 9, 0, 5, 0x60, 0x10, 0x10, 0x10, 0x60, 0x80, 0x80, 0x80, 0x60, 0,
		0, 9, 0, 5, 0x60, 0x10, 0x10, 0x10, 0x60, 0x10, 0x10, 0x10, 0x60, 0,
		0, 9, 0, 5, 0x00, 0x90, 0x90, 0x90, 0x60, 0x10, 0x10, 0x10, 0x00, 0,
		0, 9, 0, 5, 0x60, 0x80, 0x80, 0x80, 0x60, 0x10, 0x10, 0x10, 0x60, 0,
		0, 9, 0, 5, 0x60, 0x80, 0x80, 0x80, 0x60, 0x90, 0x90, 0x90, 0x60, 0,
		0, 9, 0, 5, 0x60, 0x10, 0x10, 0x10, 0x00, 0x10, 0x10, 0x10, 0x00, 0,
		0, 9, 0, 5, 0x60, 0x90, 0x90, 0x90, 0x60, 0x90, 0x90, 0x90, 0x60, 0,
		0, 9, 0, 5, 0x60, 0x90, 0x90, 0x90, 0x60, 0x10, 0x10, 0x10, 0x00, 0
	};

	bitmap_put(53, y, &police[14 * (n / 10)], 2, 2);
	bitmap_put(59, y, &police[14 * (n % 10)], 2, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche les scores de chaque joueur
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
print_score()
{
	fill_rect(53, 34, 62, 42, 1, 3);
	print_nbre(34, NbrePions - NbreBlancs);
	fill_rect(53, 53, 62, 61, 0, 3);
	print_nbre(53, NbreBlancs);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche la chane de caractre donne  l'endroit indiquant l'tat du joueur
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
print_etat(char *str, short couleur)
{
	fill_rect(3, 86 - 83 * couleur, 61, 92 - 83 * couleur, 0, 3);
	draw_str(4, 87 - 83 * couleur, str, 1, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche avec printf le nombre de coups examins par la calculatrice
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
print_nbre_examin(short couleur)
{
	static unsigned char masque[] = { 0, 5, 0, 48,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA
	};
	short   y = 78 - 65 * couleur;

	if (NbreCoups == 0)
		fill_rect(22, y, 49, 82 - 65 * couleur, 0, 3);
	printf_long(4, y, "nod: %ld", NbreCoups, 3);
	bitmap_put(4, y, masque, 1, 1);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Efface le message crit dans la zone d'un joueur
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
efface_msg(short couleur)
{
	static unsigned char masque[] = { 0, 13, 0, 48,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA,
		0x55, 0x55, 0x55, 0x55, 0x55, 0x55
	};

	if (Message[couleur] == 0)
		return;
	fill_rect(5, 64 - 45 * couleur, 50, 76 - 45 * couleur, 0, 2);
	bitmap_put(5, 64 - 45 * couleur, masque, 4, 1);
	Message[couleur] = 0;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche un message sur deux lignes dans la zone d'un joueur donn
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
disp_msg(char *msg, char *msg2, short couleur)
{
	draw_str(4, (*msg2 != 0 ? 64 : 67) - 44 * couleur, msg, 1, 3);
	draw_str(4, 71 - 44 * couleur, msg2, 1, 3);
	Message[couleur] = 1;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche un message au premier plan, en blanc dans un rectangle noir stylis
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
disp_big_msg(char *msg)
{
	FontSetSys(NORMAL);
	fill_rect(19, 39, 139, 59, 0, 3);
	fill_rect(18, 40, 140, 58, 0, 3);
	fill_rect(20, 40, 138, 58, 1, 3);
	fill_rect(19, 41, 139, 57, 1, 3);
	draw_rect(21, 42, 137, 56, 0, 3);
	draw_str(fr_eng(23, 38), 46, msg, 2, 3);
	attend_touche(0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche le rsultat de la partie
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
disp_resultat(void)
{
	short   i, j;

	i = 2 * NbreBlancs < NbrePions;

	if (2 * NbreBlancs == NbrePions)
	{
		disp_msg(fr_eng("Ex aequo !", "Tie!"), "", BLANC);
		disp_msg(fr_eng("Ex aequo !", "Tie!"), "", NOIR);
		beep(1000, 4);
		beep(4000, 4);
		beep(1000, 4);
	}
	else if (NbreOrdi == 1)
	{
		efface_msg(Ordi);
		if (i == Ordi)
		{
			disp_msg(fr_eng("J'ai gagn !", "I win!"), "", Ordi);
			for (i = 5000, j = 95; i > 600; i -= j--)
				beep(i, 2);
		}
		else
		{
			disp_msg(fr_eng("Bravo !", "You win!"), "", Ordi);
			for (i = 600, j = 1; i < 5000; i += j++)
				beep(i, 2);
		}

	}
	else
	{
		disp_msg(i ? fr_eng("Les noirs", "Blacks win!") : fr_eng("Les blancs", "Whites win!"), fr_eng("gagnent !", ""), i);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche le pion nnum  l'emplacement (x, y)
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
draw_pion(short x, short y, short num)
{
	static unsigned char pion1[] = { 0xC3, 0x81, 0x00, 0x02, 0x04, 0x0A, 0xA5, 0xC3,	// Blanc
		0xFF, 0xDB, 0xAF, 0xDF, 0xBF, 0xFF, 0xFF, 0xFF,	// Noir
		0xFF, 0xFF, 0xDB, 0xAF, 0xBF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xEF, 0xBF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,	// Noir de tranche
		0xFF, 0xFF, 0x81, 0x02, 0x08, 0x81, 0xFF, 0xFF,
		0xFF, 0xC3, 0x81, 0x02, 0x04, 0x91, 0xC3, 0xFF,
		0xC3, 0x81, 0x00, 0x02, 0x04, 0x0A, 0xA5, 0xC3,	// Blanc
		0xFF, 0xC3, 0x81, 0x02, 0x04, 0x91, 0xC3, 0xFF,
		0xFF, 0xFF, 0x81, 0x02, 0x08, 0x81, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,	// Noir de tranche
		0xFF, 0xFF, 0xFF, 0xEF, 0xBF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xDB, 0xAF, 0xBF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF
	};							// Vide

	static unsigned char pion2[] = { 0x3C, 0x42, 0x81, 0x81, 0x83, 0x85, 0x5A, 0x3C,
		0x3C, 0x66, 0xDF, 0xBF, 0xFF, 0xFF, 0x7E, 0x3C,
		0x00, 0x3C, 0x66, 0xDF, 0xFF, 0x7E, 0x3C, 0x00,
		0x00, 0x00, 0x7E, 0xDF, 0xFF, 0x7E, 0x00, 0x00,
		0x00, 0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x7E, 0x81, 0x87, 0x7E, 0x00, 0x00,
		0x00, 0x3C, 0x42, 0x81, 0x83, 0x4E, 0x3C, 0x00,
		0x3C, 0x42, 0x81, 0x81, 0x83, 0x85, 0x5A, 0x3C,
		0x00, 0x3C, 0x42, 0x81, 0x83, 0x4E, 0x3C, 0x00,
		0x00, 0x00, 0x7E, 0x81, 0x87, 0x7E, 0x00, 0x00,
		0x00, 0x00, 0x00, 0xFF, 0xFF, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x7E, 0xDF, 0xFF, 0x7E, 0x00, 0x00,
		0x00, 0x3C, 0x66, 0xDF, 0xFF, 0x7E, 0x3C, 0x00,
		0, 0, 0, 0, 0, 0, 0, 0
	};

	long    ptr = (long)Plane1 + 30 * y + ((x >> 3) & 0xFFFE);
	short   decal = 24 - (x & 15), i = 8;
	unsigned char *sprite = pion1 + 8 * num;

	for (; i--; ptr += 30)
	{
		*(long *)ptr &= ~((long)(0xff) << decal);
		*(long *)ptr |= (long)(*sprite++) << decal;
	}
	for (ptr = (long)Plane2 + 30 * y + ((x >> 3) & 0xFFFE), sprite = pion2 + 8 * num, i = 8; i--; ptr += 30)
	{
		*(long *)ptr &= ~((long)(0xff) << decal);
		*(long *)ptr |= (long)(*sprite++) << decal;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche le pion ncouleur dans la case 'caze'
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
draw_pion_case(short caze, short couleur)
{
	draw_pion(11 * (caze % 9) + 61, 11 * (short)(caze / 9) + 1, couleur);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Dessine le curseur en invers dans la case 'caze'
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
draw_curseur(short caze)
{
	static MULTI_LINE curseur = { 4, {{2, 1, 0, 8, 0}, {2, 0, 1, 0, 8}, {2, 9, 1, 9, 8}, {2, 1, 9, 8, 9}} };
	draw_multi(11 * (caze % 9) + 60, 11 * (short)(caze / 9), &curseur, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Dessine un point indiquant qu'on peut jouer dans la case 'caze'
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
draw_point(short caze)
{
	DrawPix(11 * (caze % 9) + 63, 11 * (short)(caze / 9) + 3, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche des pions qui tournent (procdure appele par un timer)
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
tourne_pion(void)
{
	RotationPion %= 12;
	RotationPion++;
	draw_pion(24, PionOrdonnee, RotationPion);
	draw_pion(126, PionOrdonnee, RotationPion);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
set_pion_ordonnee(short y)
{
	PionOrdonnee = y;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Souligne une case pour indiquer le dernier coup jou
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
souligne_case(short caze)
{
	draw_line(11 * (caze % 9) + 60, 11 * (short)(caze / 9) + 9, 11 * (caze % 9) + 69, 11 * (short)(caze / 9) + 9, 2, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Initialise la Barre de rflexion
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
init_barre(short couleur)
{
	print_etat(fr_eng("En reflexion...", "Thinking..."), couleur);
	print_nbre_examin(couleur);
	Barre = 2;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Souligne une case pour indiquer le dernier coup jou
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
avance_barre(short avance, short couleur)
{
	short   i, vieille_barre = Barre + 1;

	if (avance <= Barre)
		return;
	Barre = avance;
	for (i = 86 - 83 * couleur; i <= 92 - 83 * couleur; i++)
		draw_line(vieille_barre, i, Barre, i, 2, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  (D-)coche la case  cocher situe  l'ordonne y
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
cocher(short y)
{
	static MULTI_LINE cochage = { 3, {{2, 0, 0, 4, 4}, {2, 0, 4, 1, 3}, {2, 4, 0, 3, 1}} };
	draw_multi(39, y, &cochage, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche un lment 'str' avec une case  cocher,  l'ordonne y, et en soulignant le texte entre les abscisses x1 et x2
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
afficher_texte_box(short y, short x1, short x2, short coche, char *str)
{
	static MULTI_LINE place_coche = { 4, {{1, 0, 0, 6, 0}, {1, 6, 0, 6, 6}, {1, 6, 6, 0, 6}, {1, 0, 6, 0, 0}} };

	draw_multi(38, y - 1, &place_coche, 2);
	if (coche != 0)
		cocher(y);
	draw_str(47, y, str, 1, 2);
	draw_line(x1, y + 6, x2, y + 6, 1, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Dessine l'interface
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
dessine_interface(void)
{
	static char titre_petit[] = { 0, 8, 0, 56, 0xFF, 0x7F, 0x42, 0xF4, 0x21, 0xFE, 0x12,
		0x81, 0xF, 0x42, 0x84, 0x21, 0x2, 0x12,
		0x81, 0x8, 0x42, 0x84, 0x21, 0x2, 0x12,
		0x81, 0x8, 0x7E, 0xF4, 0x21, 0x2, 0x12,
		0x81, 0x8, 0x62, 0x86, 0x31, 0x2, 0x1B,
		0x81, 0x8, 0x62, 0x86, 0x31, 0x2, 0x1B,
		0x81, 0x8, 0x62, 0x86, 0x31, 0x2, 0x1B,
		0xFF, 0x8, 0x62, 0xF7, 0xBD, 0xFE, 0x1B
	};

	static char cote1[] = { 0, 93, 0, 69,
		0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x75, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0xF7, 0x00,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAE, 0x07, 0x00,
		0x75, 0x55, 0x55, 0x55, 0x55, 0x55, 0x59, 0xF9, 0x80,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xA7, 0xFE, 0x40,
		0x5F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xDF, 0xFF, 0xA0,
		0xA9, 0xEF, 0xFF, 0xFF, 0xFF, 0xFF, 0xDF, 0xFF, 0xB0,
		0x54, 0x0F, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0xFF, 0xD0,
		0xAA, 0x8F, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0xFF, 0xD8,
		0x54, 0x8F, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0xFF, 0xD8,
		0xAA, 0x0F, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0xFF, 0xD8,
		0x55, 0x4F, 0xFF, 0xFF, 0xFF, 0xFF, 0xBF, 0xFF, 0xD8,
		0xAA, 0x47, 0xFF, 0xFF, 0xFF, 0xFF, 0xDF, 0xFF, 0xB8,
		0x55, 0x40, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xFF, 0xB0,
		0xAA, 0x83, 0xFF, 0xFF, 0xFF, 0xFF, 0xE7, 0xFE, 0x70,
		0x55, 0x20, 0x00, 0x00, 0x00, 0x00, 0x19, 0xF9, 0xE0,
		0xAA, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x06, 0x07, 0xC0,
		0x55, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00,
		0xAA, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFC, 0x00,
		0x55, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0xAA, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x01, 0xF0, 0x00,
		0x55, 0x20, 0x00, 0x00, 0x00, 0x00, 0x06, 0x06, 0x00,
		0xAA, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x18, 0x01, 0x80,
		0x55, 0x60, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x40,
		0xAA, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
		0x55, 0x47, 0xFF, 0xFF, 0xFF, 0xFF, 0xC0, 0x00, 0x30,
		0xAA, 0x4F, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x10,
		0x55, 0x4F, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x18,
		0xAA, 0xCF, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x18,
		0x54, 0x8F, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x18,
		0xAA, 0x8F, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x18,
		0x55, 0x8F, 0xFF, 0xFF, 0xFF, 0xFF, 0xC0, 0x00, 0x38,
		0xBF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC0, 0x00, 0x30,
		0x6A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xA0, 0x00, 0x70,
		0xB5, 0x55, 0x55, 0x55, 0x55, 0x55, 0x58, 0x01, 0xE0,
		0x6A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAE, 0x07, 0xC0,
		0xB5, 0x55, 0x55, 0x55, 0x55, 0x55, 0x54, 0xFF, 0x00,
		0x6A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0xB5, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x6A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0xF5, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x35, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x57, 0x00,
		0x2A, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB, 0x00,
		0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
		0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00,
		0x0F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	};

	static char cote2[] = { 0, 93, 0, 69,
		0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0A, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFE, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0x80,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xFF, 0xC0,
		0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE0,
		0x02, 0x10, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xFF, 0xE0,
		0x01, 0x10, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xF0,
		0x01, 0x10, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xF0,
		0x01, 0x10, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xF0,
		0x00, 0x90, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xF0,
		0x00, 0x90, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF, 0xF0,
		0x00, 0x88, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xFF, 0xE0,
		0x00, 0x87, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE0,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xFF, 0xC0,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFF, 0x80,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFE, 0x00,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x01, 0xF8, 0x00,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFE, 0x00,
		0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x06, 0x07, 0x80,
		0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x18, 0x01, 0xC0,
		0x00, 0x87, 0xFF, 0xFF, 0xFF, 0xFF, 0xE0, 0x00, 0x60,
		0x00, 0x88, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x60,
		0x00, 0x90, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x30,
		0x00, 0x90, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x30,
		0x01, 0x10, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x30,
		0x01, 0x10, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x30,
		0x01, 0x10, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x30,
		0x02, 0x10, 0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x60,
		0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE0, 0x00, 0x60,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x01, 0xC0,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x07, 0x80,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFE, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFA, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00,
		0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
	};
	short   i;

	clr();
	for (i = 0; i <= 8; i++)	// Dessine le plateau
	{
		draw_line(70, 11 * i + 10, 158, 11 * i + 10, 1, 3);
		draw_line(11 * i + 70, 10, 11 * i + 70, 98, 1, 3);
	}
	draw_line(159, 9, 159, 99, 1, 3);
	draw_line(69, 99, 159, 99, 1, 3);
	fill_rect(70, 10, 158, 98, 2, 1);	// Complte les ombres du plateau
	draw_line(69, 9, 69, 99, 2, 1);
	draw_line(70, 9, 159, 9, 2, 1);

	bitmap_put(86, 0, titre_petit, 1, 3);	// Affiche '* Othello II *' en haut  droite
	bitmap_put(87, 1, titre_petit, 1, 1);
	draw_str(74, 0, "*", 1, 3);
	draw_str(147, 0, "*", 1, 3);
	draw_str(75, 1, "*", 1, 1);
	draw_str(148, 1, "*", 1, 1);
	bitmap_put(0, 2, cote1, 1, 1);	// Affiche la partie gauche de l'interface
	bitmap_put(0, 2, cote2, 1, 2);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Dessine l'image d'introduction et attend l'appui sur une touche
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
disp_intro(void)
{
	static unsigned char plan1[] = { 0, 100, 0, 160,
		0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x00, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x10, 0x04, 0x00, 0x4F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x20, 0x08, 0x00, 0x2F, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x80,
		0x00, 0x00, 0x17, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0x20, 0x0A, 0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x04, 0x00, 0x4F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x04, 0x00, 0x17, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x10,
		0x00, 0x00, 0x17, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0x10, 0x00, 0x00, 0x17, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x10, 0x00, 0x00, 0x97, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x10, 0x00, 0x01, 0x0F, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x80,
		0x00, 0x00, 0x4F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0x88, 0x00, 0x00, 0x17, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC0, 0x00, 0x00, 0x17, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xA0, 0x00, 0x00, 0x17, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC4,
		0x04, 0x80, 0x17, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xC8, 0x04, 0xC0, 0x4F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE2, 0x02, 0xC0, 0x1F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xC8, 0x02, 0xC0, 0x3F, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF4,
		0x06, 0xC2, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xE9, 0x02, 0xC7, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF9, 0x26, 0x4E, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFD, 0xF6, 0x70, 0xBF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xC0, 0x60, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0x02, 0xC0, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x07, 0x00, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFE, 0x2C, 0x00, 0x3F, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFB,
		0xE0, 0x00, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xF8, 0x00, 0x00, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xF8, 0x00, 0x00, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0xFF, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xF8, 0x00, 0x00, 0x3F, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xF8,
		0x00, 0x00, 0x3F, 0xFF, 0xFF, 0xFF, 0xF4, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0xFF, 0xFF, 0xFF, 0xF8, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xF8, 0x00, 0x00, 0xBF, 0xFF, 0xFF, 0x80, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xF8, 0x70, 0x08, 0x7F, 0xFF,
		0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xF8,
		0x8E, 0x12, 0x7F, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0xFF, 0xFF, 0xFF, 0xF9, 0x81, 0x02, 0x7F, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xF1, 0x81, 0x00, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xFC, 0xFF, 0xFF, 0xFF, 0xF1, 0x80, 0x08, 0xE0, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xFF, 0xFF, 0xFF, 0xFF, 0xF1,
		0x81, 0x0A, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0xFF,
		0xFF, 0xFF, 0xFF, 0xF8, 0x80, 0x8A, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFB, 0x80, 0x07, 0x60, 0x00, 0x00, 0xFE, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x40, 0x80, 0x00,
		0x07, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
		0x00, 0x44, 0x80, 0x00, 0x1F, 0xFF, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x03, 0xFF, 0xFF,
		0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x47, 0x80, 0x00, 0x7F, 0xFF, 0xF8, 0x00, 0x00, 0x02, 0x00, 0x02,
		0x00, 0x03, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xE1, 0x00, 0x41, 0x00, 0x00, 0x7F, 0xFF, 0xFC, 0x00,
		0x00, 0x00, 0xC0, 0x38, 0x00, 0x01, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x80, 0x00, 0x40, 0x20, 0x00,
		0xFF, 0xFF, 0xFC, 0x00, 0x00, 0x00, 0x2F, 0x80, 0x00, 0x00, 0xFF, 0xFF, 0xFF, 0xFF, 0xFC, 0x01,
		0x00, 0x43, 0x20, 0x00, 0xFF, 0xFF, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xFF,
		0xFF, 0xFF, 0xF0, 0x01, 0x00, 0x40, 0x20, 0x00, 0x7F, 0xFF, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x01, 0xF0, 0xFF, 0xFF, 0x80, 0x01, 0x00, 0x40, 0x20, 0x00, 0x3F, 0xFF, 0xF8, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xFE, 0x00, 0x01, 0x00, 0x45, 0x20, 0x00,
		0x1F, 0xFF, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0xF8, 0x00, 0x01,
		0x00, 0x80, 0xA0, 0x00, 0x07, 0xFF, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0xFF, 0xE0, 0x00, 0x01, 0x01, 0x05, 0xE0, 0x00, 0x00, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0xFF, 0x80, 0x00, 0x01, 0x02, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFE, 0x00, 0x00, 0x01, 0x02, 0x01, 0x00, 0x00,
		0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF8, 0x00, 0x00, 0x01,
		0x02, 0x03, 0xE0, 0x1F, 0x00, 0x00, 0x78, 0x00, 0x00, 0x07, 0x8F, 0x00, 0x00, 0x00, 0xFC, 0xFC,
		0xE0, 0x00, 0x00, 0x01, 0x00, 0x04, 0xA0, 0xF0, 0xC0, 0x00, 0x18, 0x00, 0x00, 0x01, 0x83, 0x00,
		0x00, 0x00, 0x78, 0x78, 0xC0, 0x00, 0x00, 0x01, 0x00, 0x01, 0x21, 0xC0, 0x70, 0x00, 0x18, 0x00,
		0x00, 0x01, 0x83, 0x00, 0x00, 0x00, 0x30, 0x30, 0x80, 0x00, 0x00, 0x01, 0x01, 0x00, 0x21, 0x80,
		0x30, 0x10, 0x18, 0x00, 0x00, 0x01, 0x83, 0x00, 0x00, 0x00, 0x30, 0x30, 0x00, 0x00, 0x00, 0x01,
		0x00, 0x00, 0x83, 0x00, 0x18, 0x30, 0x38, 0x00, 0x00, 0x01, 0x83, 0x00, 0x00, 0x00, 0x30, 0x30,
		0x00, 0x00, 0x00, 0x01, 0x00, 0x88, 0x27, 0x00, 0x1C, 0x70, 0x18, 0x00, 0x00, 0x01, 0x83, 0x00,
		0x00, 0x00, 0x34, 0x34, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x26, 0x20, 0x1C, 0xFF, 0x1B, 0xF0,
		0x1F, 0xC1, 0x83, 0x03, 0xF0, 0x00, 0x34, 0x34, 0x00, 0x00, 0x00, 0x01, 0x00, 0x01, 0x06, 0x40,
		0x1C, 0x30, 0x1A, 0x38, 0x30, 0x61, 0x83, 0x0C, 0x18, 0x00, 0x34, 0x34, 0x00, 0x00, 0x00, 0x01,
		0x00, 0x03, 0x26, 0x00, 0x0C, 0x30, 0x1C, 0x18, 0x30, 0x61, 0x83, 0x0C, 0x0C, 0x00, 0x34, 0x34,
		0x00, 0x1F, 0xE0, 0x01, 0x00, 0x06, 0x06, 0x00, 0x0C, 0x30, 0x18, 0x18, 0x60, 0x71, 0x83, 0x18,
		0x0C, 0x00, 0x34, 0x34, 0x00, 0xFF, 0xF8, 0x01, 0x00, 0x01, 0x06, 0x00, 0x0C, 0x31, 0x1A, 0x0C,
		0x7F, 0xF1, 0x83, 0x38, 0x06, 0x00, 0x34, 0x34, 0x05, 0xFF, 0xFE, 0x01, 0x00, 0x01, 0x26, 0x00,
		0x1C, 0x30, 0x38, 0x8C, 0x60, 0x01, 0x83, 0x19, 0x0E, 0x00, 0x34, 0x34, 0x07, 0xFF, 0xFF, 0x81,
		0x00, 0x0E, 0x27, 0x00, 0x1D, 0x30, 0x3A, 0x0C, 0x68, 0x11, 0x83, 0x18, 0x06, 0x00, 0x34, 0x34,
		0x0F, 0xFF, 0xFF, 0x81, 0x00, 0x04, 0xA7, 0x00, 0x18, 0x30, 0x3A, 0x1C, 0x60, 0x01, 0x83, 0x18,
		0x0E, 0x00, 0x34, 0x34, 0x1F, 0xFF, 0xFF, 0x81, 0x00, 0x06, 0xA3, 0x80, 0x3A, 0x30, 0x38, 0x0C,
		0x71, 0x01, 0x83, 0x18, 0x0C, 0x80, 0x34, 0x34, 0x1F, 0xFF, 0xFF, 0xC1, 0x00, 0x1D, 0x81, 0x80,
		0x72, 0x30, 0x38, 0x0C, 0x30, 0x21, 0x83, 0x0C, 0x0C, 0x00, 0x34, 0x34, 0x1F, 0xFF, 0xFF, 0xC1,
		0x00, 0x00, 0xA0, 0xE0, 0xE0, 0x39, 0x38, 0x1C, 0x18, 0x41, 0x83, 0x8E, 0x18, 0x00, 0x70, 0x70,
		0x0F, 0xFF, 0xFF, 0x81, 0x00, 0x03, 0x60, 0x7F, 0x86, 0x1F, 0xFE, 0x7F, 0x1F, 0x87, 0xEF, 0xC3,
		0xE0, 0x01, 0xFC, 0xFC, 0x07, 0xFF, 0xFE, 0x01, 0x00, 0x00, 0x20, 0x80, 0x0C, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xFF, 0xF8, 0x01, 0x00, 0x00, 0xF0, 0x40,
		0x14, 0x00, 0x00, 0x00, 0x08, 0x00, 0x20, 0x00, 0x00, 0x00, 0x08, 0x08, 0x00, 0x7F, 0xC0, 0x03,
		0x00, 0x00, 0x7C, 0x08, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x40, 0x00, 0x04, 0x00, 0x04, 0x00,
		0x00, 0x00, 0x00, 0x6F, 0x80, 0x02, 0xFF, 0x41, 0x40, 0x02, 0x08, 0x91, 0x00, 0x20, 0x10, 0x40,
		0x40, 0x00, 0x00, 0x28, 0x00, 0x00, 0x00, 0x2F, 0xFF, 0xBF, 0xFF, 0xC0, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x75, 0xFF, 0xFF, 0xFF, 0xE0,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xF3, 0x80, 0xF0, 0x00, 0x00, 0x00, 0x05, 0xFA,
		0xFF, 0xFF, 0xFF, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x11, 0x00, 0x10, 0x00,
		0x00, 0x00, 0x0F, 0xD5, 0xFF, 0xFF, 0xBF, 0xFC, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
		0x21, 0x06, 0x5E, 0x67, 0x00, 0x00, 0x03, 0xBE, 0xBF, 0xFD, 0x5F, 0xF8, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x01, 0xE1, 0x09, 0x53, 0x94, 0x00, 0x00, 0x03, 0xFF, 0x6A, 0xAD, 0x7F, 0xF0,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x21, 0x0E, 0x53, 0xE4, 0x00, 0x00, 0x00, 0xFD,
		0xF5, 0x6B, 0x7F, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x18, 0x52, 0x84,
		0x00, 0x00, 0x01, 0x7B, 0xEF, 0x6F, 0xDF, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
		0x85, 0xFF, 0xDE, 0xFC, 0x00, 0x00, 0x00, 0x7F, 0xEE, 0xF7, 0xFF, 0x80, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0xBF, 0xFF, 0xFE, 0x80,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x15,
		0xFF, 0xFF, 0xF6, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x02, 0x6A, 0xBF, 0xFF, 0xAA, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xAA, 0xAF, 0xFE, 0xAB, 0x40, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xB5, 0x5F, 0xFE, 0xAA, 0xA0,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x2A,
		0xB7, 0xFA, 0xD5, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x2A, 0xAB, 0xF5, 0xAA, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x15, 0x56, 0xEA, 0xAA, 0xA0, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x55, 0xF5, 0x55, 0x54,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0xAA, 0xEA, 0xAA, 0xAA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x02, 0x2A, 0xAA, 0xD5, 0x55, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xAA, 0xAB, 0x55, 0x40, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xD5, 0x55, 0x55,
		0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x05, 0x55, 0x6A, 0xAA, 0xA0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	};

	static unsigned char plan0[] = { 0, 100, 0, 160,
		0x00, 0x00, 0x00, 0x7F, 0xAE, 0xAF, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xEE, 0xD2, 0xAF, 0xB0, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xDE, 0xC7, 0x57, 0xD0, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F,
		0x5F, 0x57, 0xE8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0xDE, 0xA5, 0x97, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x5B, 0xAB, 0xB0, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x5B, 0xAB, 0xE8, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xEE,
		0xBF, 0xAB, 0xE8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0xEE, 0xDF, 0x4B, 0xE8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xEE, 0xDD, 0x26, 0x68, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xEE, 0xDA, 0x14, 0xF0, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x7F,
		0xAA, 0x15, 0xB0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x77, 0xA9, 0x13, 0xE8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0xA8, 0x4B, 0xE8, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x5F, 0xA9, 0x4B, 0xE8, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3B,
		0xA9, 0xE7, 0xE8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x37, 0xD0, 0x6B, 0xB0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1D, 0xD6, 0x2F, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x37, 0xEE, 0xAF, 0xC0, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0B,
		0xF5, 0xAD, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x16, 0xFD, 0x39, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0xDC, 0xB9, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x24, 0x2C, 0x60, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
		0x14, 0xB0, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x01, 0x81, 0xA0, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x28, 0x80, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0xDA, 0x00, 0x20, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05,
		0x58, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x05, 0xC0, 0x00, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x80, 0x00, 0x40, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x0F, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x09, 0x40, 0x00, 0x40, 0x00,
		0x00, 0x00, 0x00, 0x01, 0xFD, 0xA4, 0x00, 0x00, 0x00, 0x00, 0x01, 0x6F, 0x00, 0x00, 0x00, 0x0D,
		0x00, 0x00, 0xE0, 0x00, 0x00, 0x00, 0x0B, 0xF5, 0x00, 0x00, 0x02, 0x00, 0x10, 0x00, 0x40, 0x00,
		0x00, 0x00, 0x00, 0x0D, 0x00, 0x00, 0xA0, 0x00, 0x00, 0x05, 0xEC, 0x00, 0x04, 0x00, 0x81, 0x01,
		0x02, 0x04, 0x08, 0x00, 0x00, 0x00, 0x00, 0x0E, 0x80, 0x1D, 0x50, 0x00, 0x00, 0x7A, 0x00, 0x02,
		0x02, 0x04, 0x21, 0x08, 0x42, 0x10, 0x84, 0x08, 0x00, 0x00, 0x00, 0x05, 0x88, 0x16, 0x90, 0x00,
		0x1E, 0x80, 0x00, 0x81, 0x08, 0x42, 0x49, 0x24, 0x92, 0x49, 0x22, 0x11, 0x00, 0x00, 0x00, 0x05,
		0x78, 0x08, 0x90, 0x03, 0xC8, 0x00, 0x08, 0x21, 0x24, 0x92, 0x20, 0x12, 0x49, 0x24, 0x92, 0x49,
		0x00, 0x00, 0x00, 0x08, 0x5E, 0x98, 0x60, 0x38, 0x02, 0x02, 0x08, 0x92, 0x49, 0x24, 0x00, 0x01,
		0x24, 0x92, 0x49, 0x24, 0x00, 0x00, 0x00, 0x18, 0x50, 0x9B, 0x1F, 0xA0, 0x00, 0x84, 0x49, 0x24,
		0x92, 0x48, 0x00, 0x00, 0x24, 0x92, 0x48, 0x02, 0x00, 0x00, 0x00, 0x08, 0x53, 0x8B, 0x38, 0x04,
		0x04, 0x49, 0x24, 0x92, 0x49, 0x20, 0x00, 0x00, 0x24, 0x92, 0x40, 0x00, 0x00, 0x00, 0x00, 0x12,
		0x50, 0x88, 0x40, 0x08, 0x42, 0x92, 0x49, 0x24, 0x92, 0x40, 0x00, 0x00, 0x24, 0x92, 0x80, 0x00,
		0x00, 0x00, 0x00, 0x03, 0x51, 0x01, 0x40, 0x82, 0x49, 0x24, 0x92, 0x49, 0x24, 0xC0, 0x00, 0x00,
		0x49, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x28, 0xC8, 0x81, 0x12, 0x4B, 0x00, 0xA4, 0x92,
		0x49, 0x30, 0x00, 0x00, 0x64, 0x92, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xA8, 0x0C, 0x68, 0x92,
		0x58, 0x00, 0x69, 0x24, 0x92, 0x50, 0x00, 0x00, 0xC9, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05,
		0xA8, 0x09, 0x69, 0x24, 0xA0, 0x00, 0x1A, 0x49, 0x24, 0x9C, 0x00, 0x00, 0x24, 0x90, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x05, 0x54, 0x00, 0x69, 0x24, 0x80, 0x00, 0x04, 0xA4, 0x92, 0x4D, 0x00, 0x05,
		0x49, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1D, 0x28, 0x46, 0x72, 0x49, 0x80, 0x00, 0x02, 0x52,
		0x49, 0x25, 0x30, 0x85, 0x24, 0x92, 0x00, 0x00, 0x00, 0x00, 0x00, 0x63, 0x54, 0x06, 0x44, 0x92,
		0x00, 0x00, 0x02, 0x92, 0x49, 0x24, 0x90, 0x69, 0x29, 0x25, 0x00, 0x00, 0x00, 0x00, 0x03, 0x81,
		0x28, 0x44, 0xC9, 0x24, 0x00, 0x00, 0x00, 0x49, 0x24, 0x92, 0x49, 0x29, 0x24, 0x92, 0xE0, 0x00,
		0x00, 0x00, 0x0C, 0x09, 0x28, 0x46, 0x49, 0x24, 0x80, 0x00, 0x03, 0x24, 0x92, 0x49, 0x24, 0x92,
		0x49, 0x24, 0x9E, 0x0F, 0x00, 0x00, 0x70, 0x09, 0x4C, 0x06, 0xC5, 0x24, 0xC0, 0x00, 0x05, 0x24,
		0x92, 0x4A, 0x49, 0x24, 0x92, 0x49, 0x25, 0xF2, 0x00, 0x01, 0x81, 0x09, 0x48, 0x81, 0xC9, 0x24,
		0xA0, 0x00, 0x0C, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x94, 0x92, 0x49, 0x00, 0x06, 0x04, 0x24,
		0x55, 0x44, 0x49, 0x24, 0xB8, 0x00, 0x19, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x94, 0x92,
		0x00, 0x1C, 0x01, 0x48, 0x2A, 0x04, 0x04, 0x92, 0x4F, 0x01, 0xE9, 0x24, 0x92, 0x49, 0x24, 0x92,
		0x52, 0x49, 0x24, 0x92, 0x00, 0x60, 0x22, 0x48, 0x29, 0x04, 0x69, 0x24, 0x92, 0xFF, 0x21, 0x24,
		0x92, 0x48, 0x88, 0x49, 0x24, 0x92, 0x49, 0x24, 0x01, 0xC0, 0x24, 0x91, 0x28, 0x0C, 0xE9, 0x01,
		0x12, 0x49, 0x09, 0x24, 0x92, 0x49, 0xC2, 0x49, 0x24, 0x92, 0x01, 0x00, 0x06, 0x04, 0x49, 0x25,
		0x28, 0x0C, 0x12, 0x3F, 0x89, 0x22, 0xF1, 0x24, 0x92, 0x4F, 0xCF, 0x92, 0x49, 0x25, 0xF9, 0xF9,
		0x18, 0x22, 0x49, 0x26, 0x17, 0x00, 0x30, 0x6B, 0xE4, 0x92, 0xF1, 0x24, 0x94, 0x8F, 0xCF, 0x49,
		0x24, 0x92, 0xFC, 0xFA, 0x30, 0x12, 0x49, 0x27, 0x17, 0x06, 0x48, 0x88, 0x22, 0x58, 0xB1, 0x24,
		0x92, 0x49, 0xA3, 0x49, 0x24, 0x92, 0x72, 0x71, 0x40, 0x49, 0x24, 0x92, 0x28, 0x03, 0x4B, 0x24,
		0x59, 0x19, 0x32, 0x92, 0x49, 0x25, 0xAB, 0x64, 0x92, 0x49, 0x34, 0xB4, 0x80, 0x92, 0x49, 0x25,
		0x29, 0x86, 0x75, 0x8F, 0xDC, 0x18, 0x12, 0x44, 0x88, 0x49, 0xD3, 0xD1, 0x09, 0x24, 0xB7, 0x77,
		0x02, 0x49, 0x24, 0x92, 0x28, 0x75, 0xA6, 0x3D, 0x98, 0xBB, 0x30, 0xF1, 0x0F, 0x11, 0xEB, 0xC9,
		0xE1, 0x24, 0xB2, 0xF2, 0x22, 0x49, 0x24, 0x92, 0x28, 0x70, 0x47, 0x54, 0x89, 0xFF, 0x31, 0xF9,
		0x1F, 0xC9, 0xD3, 0xCF, 0xF9, 0x24, 0x71, 0x71, 0x12, 0x49, 0x24, 0x92, 0x28, 0x00, 0x6F, 0x24,
		0x8C, 0x38, 0xBF, 0x9C, 0x98, 0xC9, 0xE3, 0xCE, 0x3C, 0x92, 0x71, 0x78, 0x92, 0x49, 0x24, 0x92,
		0x28, 0x00, 0xCE, 0xE4, 0x9E, 0xBD, 0x3C, 0x8D, 0x60, 0x71, 0xEB, 0xD8, 0x96, 0x24, 0xF1, 0x70,
		0x92, 0xA0, 0x0A, 0x49, 0x28, 0x01, 0x6F, 0xC5, 0x36, 0xBB, 0xB2, 0x8D, 0x7B, 0x25, 0xE3, 0xDC,
		0x66, 0x92, 0x71, 0x71, 0x25, 0x00, 0x06, 0x49, 0x28, 0x00, 0x6F, 0x55, 0x37, 0x3E, 0xF0, 0xF8,
		0xFF, 0xF5, 0xE3, 0x9B, 0xEC, 0x92, 0x71, 0x71, 0x22, 0x00, 0x01, 0x92, 0x14, 0x02, 0x4F, 0x55,
		0x4D, 0xBB, 0x13, 0x59, 0xE4, 0x09, 0xEB, 0xBA, 0x86, 0x49, 0x78, 0xF1, 0x28, 0x00, 0x00, 0x25,
		0x14, 0x00, 0xA6, 0x55, 0x88, 0xBB, 0x11, 0x5D, 0xE4, 0x8D, 0xEB, 0xBB, 0x8E, 0xA4, 0x71, 0x71,
		0x30, 0x00, 0x00, 0x52, 0x18, 0x12, 0xA3, 0x56, 0xBF, 0xBD, 0x91, 0x09, 0x7A, 0xBD, 0xE3, 0xBD,
		0x44, 0xA4, 0xF1, 0xF0, 0x80, 0x00, 0x00, 0x52, 0x14, 0x01, 0x29, 0x2A, 0x91, 0xBB, 0x12, 0x99,
		0x66, 0xDD, 0xEB, 0x9E, 0x4E, 0x12, 0x72, 0x71, 0x20, 0x00, 0x00, 0x12, 0x08, 0x20, 0x75, 0xD4,
		0x65, 0xBA, 0x12, 0x99, 0x72, 0x35, 0xE3, 0xDC, 0x9D, 0xA4, 0xF1, 0xF1, 0x20, 0x00, 0x00, 0x12,
		0x00, 0x1B, 0x55, 0x49, 0x4F, 0x90, 0x9A, 0x0C, 0xBC, 0xE3, 0xD3, 0x0C, 0x7D, 0xA4, 0x38, 0x39,
		0x50, 0x00, 0x00, 0x52, 0x00, 0x20, 0x95, 0x3F, 0xD1, 0x4F, 0xDE, 0x3F, 0x07, 0xCB, 0xFF, 0xE7,
		0xFB, 0x90, 0xFF, 0xFD, 0x58, 0x00, 0x01, 0xD4, 0x80, 0x03, 0xF6, 0x2A, 0x22, 0xAA, 0x04, 0x04,
		0x4A, 0x40, 0x81, 0x12, 0x8B, 0x92, 0x04, 0x04, 0xAE, 0x00, 0x07, 0xB7, 0x40, 0x01, 0x0E, 0xB5,
		0x49, 0x6D, 0x4E, 0x97, 0x24, 0x4D, 0x49, 0xE7, 0x17, 0x49, 0x25, 0x25, 0x57, 0x80, 0x3E, 0xFD,
		0x82, 0x07, 0xA3, 0xF5, 0x5D, 0x5F, 0x5E, 0x4F, 0x4F, 0x3A, 0x35, 0xE7, 0x93, 0x24, 0x99, 0x3D,
		0x56, 0xFF, 0xEF, 0x12, 0x76, 0x9D, 0x54, 0xBE, 0xB5, 0x55, 0xF7, 0x0E, 0xD7, 0xCB, 0xEF, 0xB9,
		0xBE, 0x49, 0x7F, 0x97, 0xAB, 0x55, 0xBF, 0xF0, 0x6F, 0xDF, 0xBD, 0x37, 0x6A, 0x4A, 0x92, 0x49,
		0x24, 0xC9, 0x24, 0x90, 0x48, 0x24, 0x14, 0x92, 0x6A, 0xAB, 0x7E, 0xCA, 0x77, 0xBF, 0x57, 0x9D,
		0x54, 0x92, 0x4A, 0x49, 0x24, 0x92, 0x49, 0x23, 0xF3, 0xA4, 0xD2, 0x49, 0x56, 0xAB, 0x7A, 0xC5,
		0x3F, 0xDF, 0x25, 0x6E, 0xA4, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x91, 0x89, 0x81, 0x30, 0x40,
		0xAA, 0xB5, 0xE0, 0xAA, 0x07, 0xFD, 0x40, 0xA2, 0x92, 0x49, 0x24, 0x94, 0x92, 0x49, 0x24, 0x91,
		0x89, 0x8F, 0xBC, 0xFB, 0xAA, 0xD6, 0xFC, 0x41, 0x45, 0x52, 0xA0, 0xB6, 0x92, 0x49, 0x24, 0x92,
		0x92, 0x49, 0x24, 0x91, 0xC1, 0x9F, 0x72, 0xDE, 0xAB, 0x56, 0xEC, 0x60, 0x95, 0x52, 0x82, 0xCE,
		0xA4, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x91, 0x89, 0x5F, 0x53, 0xF4, 0xD5, 0x5A, 0xEF, 0x62,
		0x0A, 0x94, 0x87, 0x9E, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x91, 0xA5, 0x99, 0xD3, 0x9C,
		0xD5, 0x5A, 0xDC, 0x96, 0x92, 0x91, 0x3C, 0xBD, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x52, 0x49,
		0x2F, 0xE6, 0x7C, 0x65, 0x55, 0xAA, 0xDD, 0x82, 0x1F, 0x3F, 0x94, 0x76, 0xA4, 0x92, 0x49, 0x24,
		0x92, 0x49, 0x24, 0x90, 0x84, 0x02, 0x04, 0x20, 0xD5, 0x55, 0x6F, 0xE9, 0x54, 0x25, 0x11, 0x76,
		0x92, 0x49, 0x24, 0x94, 0x92, 0x49, 0x24, 0x92, 0x48, 0x92, 0x44, 0x89, 0x4A, 0xA5, 0x5F, 0xEA,
		0x08, 0x09, 0x09, 0x7A, 0xA4, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x94, 0x92, 0x49, 0x24, 0x92,
		0x49, 0x25, 0x59, 0x95, 0x41, 0x14, 0x55, 0x5A, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49,
		0x24, 0x92, 0x49, 0x24, 0xA4, 0x92, 0x6F, 0x55, 0x55, 0xDD, 0x54, 0xBA, 0xA4, 0x92, 0x49, 0x24,
		0x92, 0x49, 0x24, 0x92, 0x49, 0x49, 0x24, 0x92, 0x49, 0x24, 0xB7, 0x4A, 0xA3, 0xB5, 0x55, 0x5A,
		0xA4, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x29, 0x24, 0x92, 0x49, 0x24, 0xAF, 0xD5,
		0x4B, 0x65, 0x2A, 0xBD, 0x52, 0x49, 0x24, 0x92, 0x49, 0x25, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49,
		0x24, 0x92, 0x57, 0xD5, 0x54, 0xCA, 0x55, 0x7F, 0x52, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49,
		0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x4D, 0xEA, 0xA9, 0xD5, 0x55, 0x5F, 0x69, 0x24, 0x92, 0x4A,
		0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x2A, 0xFA, 0xAA, 0x8A, 0xAA, 0xAB,
		0xD5, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x49, 0x25, 0x7F,
		0x55, 0x15, 0x55, 0x55, 0xF5, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x29, 0x24,
		0x92, 0x49, 0x24, 0xB9, 0xD5, 0x55, 0x2A, 0xAA, 0xFA, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92,
		0x49, 0x29, 0x24, 0x92, 0x49, 0x24, 0x92, 0x57, 0xFD, 0x55, 0x54, 0xAA, 0xBA, 0x92, 0x49, 0x24,
		0xA4, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x55, 0xFD, 0x2A, 0xAA, 0xAA,
		0xBD, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x2A,
		0xFA, 0xAA, 0x95, 0x55, 0x5D, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24, 0x92, 0x49, 0x24
	};

	clr();
	bitmap_put(0, 0, plan0, 1, 1);
	bitmap_put(0, 0, plan1, 1, 2);
	attend_touche(0);
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche un rectangle qui s'agrandit pour prendre tout l'cran
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
transition_debut(void)
{
	short   i;

	for (i = 0; i <= 49; i++)
	{
		draw_rect(49 - i, 49 - i, 110 + i, 50 + i, 1, 3);
		draw_rect(50 - i, 50 - i, 109 + i, 49 + i, 0, 3);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Affiche un rectangle qui recouvre tout l'cran en commenant par les bords
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void
transition_fin(void)
{
	short   i;

	for (i = 49; i >= 0; i--)
	{
		draw_rect(49 - i, 49 - i, 110 + i, 50 + i, 1, 3);
		attend(2);
	}
}
